--$Name: Один в пустоте$
--$Version: 0.0$
--$Author: Андрей Лобанов$

instead_version "1.9.1"

require "quotes"
require "dash"
require "hideinv"
require "sprites"
require "theme"
require "kbd"
require "timer"
dofile "files.lua"
dofile "objects.lua"

global {
   scr_x = 1,
   scr_y = 1,
   x = 21,
   y = 15,
   fuel = 22,
   oxygen = 21,
   lock = false,
}

function init()
   font = sprite.font ("theme/Jura-Regular.ttf", 12)
   logo = sprite.font ("theme/Jura-Regular.ttf", 48)
   bg = sprite.load ("theme/bg.png")
   me = sprite.load ("img/cross.png")
   bot = sprite.load ("img/triangle.png")
   station = sprite.load ("img/square.png")
   ship = sprite.load ("img/rhombus.png")
   asteroid = sprite.load ("img/circle.png")
   sector = sprite.box (20, 20, "#00FF00")

   hook_keys ( "escape", "return", "up", "down", "left", "right", "[1]", "[2]", "[3]", "[4]", "[5]", "[6]", "[7]", "[8]", "[9]", "s", "y", "u", "h", "j", "k", "l", "b", "n", "m", "f" )
   set_music ("mus/A.ogg")
end

function start()
   if here() == flight then
      redraw()
   end
end

put_sprite = function (spr, x, y)
   sprite.draw (spr, flight.pic, x * 20 - 10, y * 20 + 10)
end

redraw = function ()
   sprite.copy (bg, flight.pic, 0, 0)
   sprite.draw (me, flight.pic, 0, 0)
   for i, a in pairs (objects) do
      if a.x > scr_x and a.x < scr_x + 40 and
      a.y > scr_y and a.y < scr_y + 30 then
	 if a.type == 0 then
	    put_sprite (station, a.x - scr_x, a.y - scr_y)
	 elseif a.type == 1 then
	    put_sprite (bot, a.x - scr_x, a.y - scr_y)
	 elseif a.type == 2 then
	    put_sprite (asteroid, a.x - scr_x, a.y - scr_y)
	 elseif a.type == 3 then
	    put_sprite (ship, a.x - scr_x, a.y - scr_y)
	 end
	 if a.name then
	    oname = sprite.text (font, a.name, "#00BB00")
	    local w, h = sprite.size (oname)
	    sprite.draw (oname, flight.pic, (a.x - scr_x) * 20 - w / 2, (a.y - scr_y) * 20 + 10 - h)
	    sprite.free (oname)
	 end
	 if a.x == x and a.y == y then
	    objects[i].known = true
	 end
	 if a.known then
	    odesc = sprite.text (font, a.desc, "#00BB00")
	    local w, h = sprite.size (odesc)
	    sprite.draw (odesc, flight.pic, (a.x - scr_x) * 20 - 30 / 2, (a.y - scr_y) * 20 + 30)
	    sprite.free (odesc)
	 end
      end
   end
   tfuel = sprite.text (font, "Топливо: " .. tostring (fuel), "#00BB00")
   toxygen = sprite.text (font, "Кислород: " .. tostring (oxygen), "#00BB00")
   sprite.draw (tfuel, flight.pic, 0, 0)
   sprite.draw (toxygen, flight.pic, 100, 0)
   sprite.free (tfuel)
   sprite.free (toxygen)
end

make_step = function()
   fuel = fuel - 1
   oxygen = oxygen - 1
end

scan = function ()
   lock = true
   for i, a in pairs (objects) do
      if a.x >= x - 5 and a.x <= x + 5 and
      a.y >= y - 5 and a.y <= y + 5 then
	 objects[i].known = true
      end
   end
   timer:set (50)
end

main = room {
   nam = "",
   pic = function (s)
      s.pic = sprite.text (logo, "Один в пустоте", "#00FF00")
   end,
   dsc = txtc (img ("img/logo_ship.png") .. "^^...Я нахожусь в кабине рабочего бота. Обзорный экран не функционирует. Я ничего не помню..."),
   act = function (s, w)
      if w == "Start" then
	 walk (flight)
      elseif w == "Controls" then
	 walk (controls)
      end
   end,
   obj = { vobj ("Start", txtc ("{Начать игру}^")), vobj ("Controls", txtc ("{Управление}")) },
}

controls = room {
   nam = "Клавиши управления",
   dsc = "Управление движением:^^" .. img ("img/keys_move.png") .. "^^" .. img ("img/keys_map.png") .. " карта" .. "^^" .. img ("img/keys_scan.png") .. " сканер" .. "^^" .. img ("img/keys_files.png") .. " просмотр файлов" .. "^^" .. img ("img/keys_docking.png") .. " стыковка" .. "^^" .. img ("img/keys_esc.png") .. " выход^^-------------------------------------------------------------------------------------------",
   enter = function ()
      theme.win.geom (80, 20, 640, 560)
   end,
   exit = function ()
      theme.win.geom (40, 20, 720, 560)
   end,
   act = function ()
      back()
   end,
   obj = { vobj ("Back", "{Назад}") },
}

flight = room {
   alpha = 128,
   nam = "",
   pic = sprite.box (800, 600, "#000000"),
   enter = function ()
      theme.win.geom (0, 0, 800, 600)
      redraw()
   end,
   timer = function (s)
      redraw()
      for a = 16, 26 do
	 for b = 10, 20 do
	    sprite.draw (sector, s.pic, a * 20 - 30, b * 20 - 10, s.alpha)
	 end
      end
      s.alpha = s.alpha - 8
      if s.alpha <= 0 then
	 s.alpha = 128
	 timer:stop()
	 redraw()
	 lock = false
      end
   end,
   kbd = function (s, down, key)
      if down and not lock then
	 if key == "up" or key == "[8]" or key == "k" then
	    y = y - 1
	    scr_y = scr_y - 1
	    make_step()
	 elseif key == "down" or key == "[2]" or key == "j" then
	    y = y + 1
	    scr_y = scr_y + 1
	    make_step()
	 elseif key == "left" or key == "[4]" or key == "h" then
	    x = x - 1
	    scr_x = scr_x - 1
	    make_step()
	 elseif key == "right" or key == "[6]" or key == "l" then
	    x = x + 1
	    scr_x = scr_x + 1
	    make_step()
	 elseif key == "[7]" or key == "y" then
	    x = x - 1
	    y = y - 1
	    scr_x = scr_x - 1
	    scr_y = scr_y - 1
	    make_step()
	 elseif key == "[9]" or key == "u" then
	    x = x + 1
	    y = y - 1
	    scr_x = scr_x + 1
	    scr_y = scr_y - 1
	    make_step()
	 elseif key == "[1]" or key == "b" then
	    x = x - 1
	    y = y + 1
	    scr_x = scr_x - 1
	    scr_y = scr_y + 1
	    make_step()
	 elseif key == "[3]" or key == "n" then
	    x = x + 1
	    y = y + 1
	    scr_x = scr_x + 1
	    scr_y = scr_y + 1
	    make_step()
	 elseif key == "s" then
	    scan()
	 elseif key == "m" then
	    walk (map)
	 elseif key == "return" then
	    walk (docking)
	 elseif key == "f" then
	    set_sound ("snd/kbd.ogg", 1, 1)
	    walk (files)
	 end
	 redraw()
      end
   end,
}

map = room {
   nam = "",
   pic = sprite.box (800, 600, "#000000"),
   dsc = function (s)
      sprite.copy (bg, s.pic, 0, 0)
      sprite.fill (s.pic, 401 + x * 2, 0, 1, 600, "#007700")
      sprite.fill (s.pic, 0, 301 + y * 2, 800, 1, "#007700")
      for i, a in pairs (objects) do
	 sprite.fill (s.pic, 400 + a.x * 2, 300 + a.y * 2, 3, 3, "#00FF00")
      end
   end,
   kbd = function (s, down, key)
      if down then
	 if key == "escape" then
	    back()
	 end
      end
   end,
}

docking = room {
   index = 0,
   o = 0,
   f = 0,
   ob = "",
   filename = "",
   nam = function (s)
      return s.ob
   end,
   dsc = function (s)
      v = txtb ("Стыковка: ") .. "Успешно^^" .. txtb("ЗАПРАВКА...^^") .. txtb ("Получено:^") .. tostring (s.f) .. " топлива^" .. tostring (s.o) .. " кислорода^^" .. txtb ("СОЕДИНЕНИЕ С БАЗОЙ ДАННЫХ...")
      if s.filename ~= "" then
	 v = v .. txtb ("^^Получены файлы:") .. s.filename
      else
	 v = v .. txtb ("^^ФАЙЛЫ ОТСУТСТВУЮТ")
      end
      v = v .. "^^-------------------------------------------------------------------------------------------"
      return v
   end,
   enter = function (s)
      theme.win.geom (80, 20, 640, 560)
      for i, a in pairs (objects) do
	 if a.type ~= 2 and a.x == x and a.y == y then
	    s.index = i
	 end
      end
      if s.index == 0 then
	 walk (flight)
      else
	 fuel = fuel + objects[s.index].fuel
	 oxygen = oxygen + objects[s.index].oxygen
	 s.f = objects[s.index].fuel
	 s.o = objects[s.index].oxygen
	 s.ob = objects[s.index].name
	 objects[s.index].fuel = 0
	 objects[s.index].oxygen = 0
	 if objects[s.index].files then
	    for j, b in pairs (objects[s.index].files) do
	       s.filename = s.filename .. "^" .. b.nam
	       placef (b, files)
	       objects[s.index].files = nil
	    end
	 end
      end
   end,
   exit = function (s)
      s.index = 0
      s.filename = ""
   end,
   kbd = function (s, down, key)
      if down then
	 if key == "escape" then
	    back()
	 end
      end
   end,
   act = function ()
      back()
   end,
   obj = { vobj ("Back", "{Назад}") },
}

files = room {
   nam = "Файлы",
   look = function (s)
      local i, vv, o
      local n, tab = 1, { "0%", "25%", "50%", "75%" }
      for i, o in stead.opairs (objs()) do
	 o = stead.ref (o)
	 if isObject (o) then
	    if n < 4 then
	       vv = stead.par (stead.space_delim, vv, txttab(tab[n]) .. o:look())
	    else
	       vv = stead.par (stead.space_delim, vv, txttab(tab[n]) .. o:look() .. "^")
	    end
	    n = n + 1
	    if n == 5 then
	       n = 1
	    end
	 end
      end
      return stead.cat (vv, stead.space_delim)
   end,
   enter = function ()
      theme.win.geom (80, 20, 640, 560)
   end,
   kbd = function (s, down, key)
      if down and key == "escape" then
	 back()
      end
   end,
   act = function ()
      back()
   end,
   obj = { vobj ("Back", "^-------------------------------------------------------------------------------------------^^{Назад}") },
}
